
/* -----------------------------------------------------------------------
   A. Veneziani - Programma che date due date, individua la differenza
                  in giorni tra le due date, facendo riferimento ad
                  una data fissa convenzionale posta all' 1-1-1970

                  Scritto in C++ Builder 6
   ------------------------------------------------------------------------ */               

#include <iostream>

using namespace std;

// struttura (ottimizzata) preposta a contenere una data
struct data {
    char giorno;
    char mese;
    short anno;
};

// indica quanti giorni sono passati
// tra il 31 dic dell' anno (y - 1)
// ed il 1970
// fissando come riferimento la data 1-1-1970)
int giorni_da_anni(short y)
{
     int cc, gg;

     gg = 0;
     for(cc = 1970; cc < y; cc++)
        if ((cc % 4) == 0)
           gg = gg + 366;
        else
           gg = gg + 365;   

     return(gg);      
};

// indica quanti giorni sono passati tra
// il mese di gennaio (sempre facendo riferimento
// alla data 1-1-1970) ed il mese (m - 1)
int giorni_da_mesi(short m, short y)
{
    int cc, gg;

    gg = 0;
    for (cc = 1; cc < m; cc++)
    switch (cc)
    {
        // conteggio giorni per i mesi di 31 giorni
        case 1:
        case 3:
        case 5:
        case 7:
        case 8:
        case 10:
        case 12:  gg = gg + 31;
                  break;

        // conteggio giorni per febbraio          
        case 2:   if ((y % 4) == 0)
                     gg = gg + 29;
                  else
                     gg = gg + 28;
                  break;

        // conteggio giorni per i mesi di 30 giorni
        case 4:
        case 6:
        case 9:
        case 11:   gg = gg + 30;
                   break;
    }

    return(gg);    // rende i giorni conteggiati
};

int main()
{
     data dt1, dt2;
     int g, m , a;
     int giorni_tot, delta_giorni, delta_giorni_1, delta_giorni_2;

     // legge le due date
     cout << "Programma che effettua un confronto tra date." << endl;
     // legge la prima data
     cout  << "Dai la prima data:  ";
     cin >> g >> m >> a;
     dt1.giorno = g;
     dt1.mese = m;
     dt1.anno = a;
     // legge la seconda data
     cout  << "Dai la seconda data:  ";
     cin >> g >> m >> a;
     dt2.giorno = g;
     dt2.mese = m;
     dt2.anno = a;

     // conteggio del delta giorni dall' 1-1-1970
     delta_giorni_1 = 0;
     delta_giorni_1 = giorni_da_anni(dt1.anno);
     delta_giorni_1 = delta_giorni_1 + giorni_da_mesi(dt1.mese, dt1.anno);
     delta_giorni_1 = delta_giorni_1 + dt1.giorno;
     
     // conteggio del delta giorni dall' 1-1-1970
     delta_giorni_2 = 0;
     delta_giorni_2 = giorni_da_anni(dt2.anno);
     delta_giorni_2 = delta_giorni_2  + giorni_da_mesi(dt2.mese, dt2.anno);
     delta_giorni_2 = delta_giorni_2  + dt2.giorno;

     // differenza tra i due delta da' la differenza tra le due date
     delta_giorni = delta_giorni_2 - delta_giorni_1;

     // output del risultato
     cout << "Le due date proposte differiscono per giorni:  "
          << delta_giorni << endl;

     system("PAUSE");       // esce dal programma solo se viene premuto un tasto

     return(0);

}
